from ox_script import *
import time
import socket
form_list = []
hostname = socket.gethostname()
#host = socket.gethostbyname(hostname)
ip_addresses = socket.gethostbyname_ex(hostname+'.local.')[2]
host=ip_addresses[0]
#host='199.9.10.109'
port= 8888
# The following code is used to initialize the UI on the printer
def find_forms():
    global selected_form
    global form_list
    form_list = [file for file in os.listdir() if file.endswith(".txt")]
    if len(form_list) != 0:
        selected_form = form_list[0]
        
def update_selected_form(value):
    global form_list
    global selected_form
    selected_form = form_list[int(value)]
#    create_excel(selected_form + datetime.datetime.now())
find_forms()
PTK_UIInit(
    PTK_UIPage(
        connection_status := PTK_UITextBox(title=f"{host} 连接状态:", value=f"Port {port} 等待连接中..."),
        form_list_controller := PTK_UIList(
            title="模板名称",
            items=form_list,
            valueType="int",
            value=0,
            Onpressed=update_selected_form,
        ),
        variable := PTK_UITextBox(title="打印变量:", value="---"),
    ),
    # Setting require_execute_confirmation to False will allow the script to run without the need to press the execute button on the printer
    require_execute_confirmation=False,
)


import socket
info : str = PTK_GetPrinterInfo ()
print(info)
# { "printerName": "",  "printerType": "",  "dpi": "",  "domainName": "", "printerMac": "","ethStatus": "", "usbStatus": "","wifiStatus": "", "bleStatus": "","deviceSn": "",}

# 创建 socket
server_socket = socket.socket(socket.AF_INET, socket.SOCK_STREAM)

# 绑定地址和端口
server_address = (host, port)
server_socket.bind(server_address)

# 监听连接
server_socket.listen(5)

#print("服务器正在监听端口 8888...")

while True:
    try:
        # 等待客户端连接
        client_socket, client_address = server_socket.accept()
        connection_status.update(f"来自{client_address}的链接")

        # 读取客户端数据
        while True:
            data = client_socket.recv(1024)
            if not data:
                # 客户端断开连接
                connection_status.update(f"电脑端{client_address}断开了连接")
                break

            # 处理接收到的数据
            variable.update(data.decode())
            cmd = PTK_UpdateAllFormVariables(selected_form, Input1=data.decode())
            PTK_SendCmdToPrinter(cmd)
            print("收到数据:", data.decode('utf-8'))

    except ConnectionResetError:
        # 客户端断开连接时的异常处理
        connection_status.update(f"电脑端{client_address}强制断开了连接")
        print("客户端强制断开连接")
        break

    finally:
        # 关闭连接
        client_socket.close()

# 关闭服务器 socket
server_socket.close()
print("服务端关闭")
