# coding=utf-8
from ox_script import *
import time
import datetime
# 导入 requests 包
import requests
import json

controller = PTK_UIInit(
    PTK_UIPage(
        # 可以通过controller['Widget_1']来获取变量
        PTK_UITextBox(title='状态', value='等待启动')
    ),
    require_execute_confirmation=False,
)


# 每秒钟查询一次数据库检测有没有新数据
# 轮询数据库的方式会创建不必要的网络通讯，在大型项目中容易影响数据库的性能，建议终端设备连接服务器，由服务器访问数据库，数据有更新的情况下再由服务器推送数据到终端设备
while True:
	controller['Widget_1'].update('正在监听数据')
#	print ("1")
	time.sleep(5)
	# 查看数据库是否有数据是在'previous_key'创建时间之后创建的数据
	url = 'https://test.com/bj-gaia-feedtrace/tenantNoPrintList'
	data = {'companyId':'847536075874816000','deviceId':'849002547155357696','status':'0'}
	header = {'Content-Type':'application/json'}
	response = requests.post(url,json=data,headers=header)
#	print(response)
#	print(response.headers)
#	print(response.text)
#	print(response.json())
	req_jason = response.json() # 获取数据
	if req_jason["data"]!="":
		controller['Widget_1'].update('接收到新数据，开始打印')
#		print(req_jason["data"])
		for row in req_jason['data']:
#			print(row['backUrl'])
#			print(row['createTime']
# 			替换'row[1]'为你想要打印的值
			cmdd = PTK_UpdateAllFormVariables(
				'commandssyt.txt',
				Input1=str(row['createTime'])[:10],
				Input2=str(row['createTime'])[11:19],
				Input3=str(row['backUrl']),
			)
			PTK_SendCmdToPrinter(cmdd)
#			PTK_SetPortback(3)
			PTK_PrintLabel(1, int(row['printNum']))
#			PTK_PrintLabel(1, 1)

			# 等待打印完成
			status = PTK_GetPrinterStatus()
#			print (status)
#			print("1")
			updateUrl = 'https://beta-shanshui-gateway.shanshuiyuntu.com/bj-gaia-feedtrace/printLogUpdate'
			updateHeader = {'Content-Type':'application/json'}
#			print ("2")
			#判断是否打印成功
			if status == False:
#				print("执行反馈出错语句")
			#	controller['Widget_1'].update('打印出错')
				updateData = {'id':row['id'],'errorLog':'打印出错','status':'-1'}	
				
			else:
#				print("执行反馈成功语句")
				updateData = {'id':row['id'],'errorLog':'打印成功','status':'1'}
				
			requests.post(updateUrl,json=updateData,headers=updateHeader)
#			print("updateHeader")
	time.sleep(10)
